const questionHelper = require("../Helper/QuestionHelper");
const path = require("path");
const util = require("util");
const fs = require("fs");

const ERROR = {FILED_TO_CREATE: 7001, NOT_FOUND: 7002, NOT_IN_STEP: 7003}

function getRedFlagForm(pId) {
    return new Promise((resolve, reject) => {
        const redFlag = questionHelper.RF;

        const outputPath = path.resolve(__dirname, util.format(process.env.PDF_PRIVATE_PATH, pId))
        if (fs.existsSync(outputPath)) redFlag.buttons[0].url = util.format(process.env.PDF_PUBLIC_PATH, pId);
        else return reject(ERROR.NOT_FOUND);

        resolve(redFlag)
    })
}

function getAllCuredForm(pId) {
    return new Promise((resolve, reject) => {
        const allCured = questionHelper.AC;

        resolve(allCured)
    })
}

function isRedFlag(assessment) {
    const questionHelper = require('../Helper/QuestionHelper')

    if (["p3m2o3", "p3m2o4", "p3m2o5"].includes(assessment.p3m2) && assessment.p3m1 === 'p3m1o1') return true

    return questionHelper.p5.children.some(redFlagField => assessment[redFlagField.id] === "1")
}


module.exports = {
    getRedFlagForm ,ERROR,isRedFlag,getAllCuredForm
};