const jwt = require('jsonwebtoken');
const responseHelper = require('./ResponseHelper')

function getAccessToken(userId) {
    return jwt.sign(
        {'UK': userId},
        process.env.ACCESS_TOKEN_SECRET,
        {expiresIn: '30d'});
}

function getRefreshToken(userId) {
    return jwt.sign(
        {'UK': userId},
        process.env.REFRESH_TOKEN_SECRET,
        {expiresIn: '60d'});
}

function auth(req, res, next) {
    const accessToken = req.body.accessToken;
    try {
        if (accessToken) {
            jwt.verify(
                accessToken,
                process.env.ACCESS_TOKEN_SECRET,
                (err, decoded) => {
                    if (err) return res.status(403).json({success:false,message: responseHelper.sessionExpire}) // there is invalid authentication token
                    req.userId = decoded.UK
                    next();
                }
            )
        }else res.status(401).json({success:false,message: responseHelper.needAuth}) // there is no authentication token

    } catch (e) {
        return res.status(401).json({success:false,message: responseHelper.sessionExpire}) // there is invalid authentication token
    }
}

module.exports = {
    getAccessToken,
    auth,
    getRefreshToken,
}