const mysql = require('mysql2/promise');

const dbConnection = mysql.createConnection({
    host: 'localhost',
    user: process.env.DB_USER,
    password: process.env.DB_PASS,
    database: process.env.DB_NAME
})


async function getArray(data) {
    return data[0]
}

async function personalize(data, responsible, personalize) {
    return data[0].map(e => personalize(e, responsible))
}

function getInsertId(data, notUpdateError) {
    return new Promise((resolve, reject) => {
        if (!data[0].affectedRows && notUpdateError) return reject(notUpdateError)

        resolve(data[0].insertId)
    })
}

function getAllInsertId(data, notUpdateError) {
    return new Promise((resolve, reject) => {
        const affectedRows = data[0].affectedRows;
        const firstInsertId = data[0].insertId;
        if (!affectedRows && notUpdateError) return reject(notUpdateError)

        const insertIds = []

        for (let i = firstInsertId; i < firstInsertId + affectedRows; i++)
            insertIds.push(i)

        resolve(insertIds)
    })
}

function mustUpdate(data, notUpdateError) {
    return new Promise((resolve, reject) => {
        if (notUpdateError && !data[0].affectedRows && notUpdateError) return reject(notUpdateError)

        resolve(data[0].affectedRows)
    })
}

function getSingleton(data, notFoundError) {
    return new Promise((resolve, reject) => {
        data = data[0] ?? data
        if (data.length === undefined) return resolve(data)
        if (!data.length) return notFoundError ? reject(notFoundError) : resolve()

        resolve(data[0])
    })
}

module.exports = {dbConnection, getSingleton, getArray, mustUpdate, getInsertId, personalize, getAllInsertId}