const treatmentController = require("../Controller/TreatmentController");
const userController = require("../Controller/UserController");
const relationController = require("../Controller/RelationController");
const assessmentsController = require("../Controller/AssessmentsController");

const questionHelper = require("./QuestionHelper");
const responseHelper = require("./ResponseHelper");

function nextOfTreatment(userId) {
    return treatmentController.getState(userId)
        .then(treatment => {
            const currentTreatment = treatment['t_category'];
            switch (treatment.state) {
                case treatmentController.STATE.CURED:
                    return userController.updateStep(userId, relationController.findAdvanceTreatment(currentTreatment))
                        .then(nextCategoryName => {

                            if (nextCategoryName === 'AC')
                                return questionHelper.AC;


                            return treatmentController.createTreatment(userId, nextCategoryName)
                        })
                        .then(result => result)

                case treatmentController.STATE.NOT_CURED:
                    const incrementTreatment = relationController.findIncrementTreatment(currentTreatment)

                    if (incrementTreatment === undefined) {
                        return assessmentsController.getLastUserStep(userId)   //User not cured so return to continue the assessment
                            .then(nextStep => userController.updateStep(userId, nextStep))
                            .then(nextStep => questionHelper[nextStep])
                    } else if (incrementTreatment === "NTV") {
                        return userController.updateStep(userId, incrementTreatment)   //User not cured so need to visit
                            .then(nextStep => questionHelper[nextStep])
                    } else
                        return treatmentController.createTreatment(userId, incrementTreatment)  //User not cured so find a new treatment

                default:
                    return Promise.reject(responseHelper.Treatment.notValid)
            }

        })
}

function getNeedToVisit() {
    
}

module.exports = {nextOfTreatment}